'use strict';

var querystring = require('querystring');
var log = require('../log');

module.exports = function () {
  return function (_ref) {
    var res = _ref.res,
        headers = _ref.res.headers,
        body = _ref.body;


    var header = Object.keys(headers).find(function (name) {
      return name.toLowerCase() === 'content-type';
    });

    var raw = body;

    if (/json|javascript/.test(headers[header])) {
      try {
        body = JSON.parse(body);
      } catch (err) {}
    }

    if (/application\/x-www-form-urlencoded/.test(headers[header])) {
      try {
        body = querystring.parse(body);
      } catch (err) {}
    }

    log({ json: body });

    return { res, body, raw };
  };
};